org.codehaus.groovy.ast.expr

## Class GStringExpression

- java.lang.Object
- - org.codehaus.groovy.ast.ASTNode
  - - org.codehaus.groovy.ast.AnnotatedNode
    - - org.codehaus.groovy.ast.expr.Expression
      - - org.codehaus.groovy.ast.expr.GStringExpression

    public class GStringExpression
    extends Expression

Represents a String expression which contains embedded values inside it such as "hello there ${user} how are you" which is expanded lazily

### Constructor Summary

Constructors
Constructor and Description
`GStringExpression(java.lang.String verbatimText)`
`GStringExpression(java.lang.String verbatimText, java.util.List<ConstantExpression> strings, java.util.List<Expression> values)`

### Method Summary

Methods
`void` `addString(ConstantExpression text)`
`void` `addValue(Expression value)`
`Expression` `asConstantString()`
`java.util.List<ConstantExpression>` `getStrings()`
`java.lang.String` `getText()`
`Expression` `getValue(int idx)`
`java.util.List<Expression>` `getValues()`
`boolean` `isConstantString()`
`java.lang.String` `toString()`
`Expression` `transformExpression(ExpressionTransformer transformer)` Return a copy of the expression calling the transformer on any nested expressions
`void` `visit(GroovyCodeVisitor visitor)`

### Methods inherited from class org.codehaus.groovy.ast.expr.Expression

`getType, setType, transformExpressions, transformExpressions`

### Methods inherited from class org.codehaus.groovy.ast.AnnotatedNode

`addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`

### Methods inherited from class org.codehaus.groovy.ast.ASTNode

`copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getNodeMetaData, putNodeMetaData, removeNodeMetaData, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setNodeMetaData, setSourcePosition`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### GStringExpression

    public GStringExpression(java.lang.String verbatimText)

#### GStringExpression

    public GStringExpression(java.lang.String verbatimText,
                     java.util.List<ConstantExpression> strings,
                     java.util.List<Expression> values)

### Method Detail

#### visit

    public void visit(GroovyCodeVisitor visitor)

Overrides:
  `visit` in class `ASTNode`

#### transformExpression

    public Expression transformExpression(ExpressionTransformer transformer)

Description copied from class: `Expression`
Return a copy of the expression calling the transformer on any nested expressions

Specified by:
  `transformExpression` in class `Expression`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### getText

    public java.lang.String getText()

Overrides:
  `getText` in class `ASTNode`

#### getStrings

    public java.util.List<ConstantExpression> getStrings()

#### getValues

    public java.util.List<Expression> getValues()

#### addString

    public void addString(ConstantExpression text)

#### addValue

    public void addValue(Expression value)

#### getValue

    public Expression getValue(int idx)

#### isConstantString

    public boolean isConstantString()

#### asConstantString

    public Expression asConstantString()